function val = acquisition_ei(x, bo)
%
% Acquisition function for Bayesian Optimization
%  Expected Improvement Criteria 
%

n = bo.n;
X = bo.input(1:bo.n, :);
Y = bo.output(1:bo.n, :);
xstar = x;
KX = kernel_ardmatern(X, X, bo);
Kxstar = kernel_ardmatern(xstar, xstar, bo);
KXxstar = kernel_ardmatern(X, xstar, bo);

gpvar = Kxstar - KXxstar'/(KX + 1E-4*eye(n, n))*KXxstar;
gpvar = abs(gpvar);
gpmean = KXxstar'/(KX + 1E-4*eye(n, n))*Y;

fmin = min(Y);
gamma = (fmin - gpmean)/sqrt(gpvar);
Phi = cdf('Normal', gamma, 0, 1);

val = sqrt(gpvar) * gamma * Phi + pdf('Normal', gamma, 0, 1);